% Social Golfer problem
% http://4c.ucc.ie/~tw/csplib//prob/prob010/index.html

% Februar 7 2003: Version 0.4
% Pairwise representation + compound(week,player)

golf3(G,S,W,R) :-
	% Data
	N is G*S,
	length(R,N),
	init_triangle(R,N,W),
	length(TriSInf,N),
	triangle_strict_inf(R,TriSInf,N),
	length(Square,N),
	triangle_to_square(TriSInf,R,Square),
	flatten(R,Vars),
	% Breaking symmetries statically
	nth(1,R,First_Player),First_Player=[_|RFirst_Player],
	ordering_weeks(RFirst_Player),
	% Constraint
	group_buildings(Square,R,W,S,N),
	% Redundant constraints
%	reverse(TriSInf,RStrictInf),
%	Wp1 is W+1,
%	plus_diag(RStrictInf,TriInf,Wp1),
%	transitivity_redund(TriInf),
	% Labeling
	randomize,	
	fd_labeling(Vars,[variable_method(first_fail),value_method(middle)]),
	convert_repr(Square,1,ListList,W,G),
	nl,nl,nl,write_sol(ListList).
golf3_sbds(G,S,W,Square) :-
	% Data
	N is G*S,
	length(R,N),
	init_triangle(R,N,W),
	length(TriSInf,N),
	triangle_strict_inf(R,TriSInf,N),
	length(Square,N),
	triangle_to_square(TriSInf,R,Square),
	flatten(Square,LVars),

	% Constraint
	group_buildings(Square,R,W,S,N),
	
	% Redundant constraints
	NbGr is S*(S-1)*G // 2,
	flatten(TriSInf,TriSFlat),
	group_redund(TriSFlat,NbGr,W),
%	reverse(TriSInf,RStrictInf),
%	Wp1 is W+1,
%	plus_diag(RStrictInf,TriInf,Wp1),
%	transitivity_redund(TriInf),
	
	% Breaking symmetries statically
	nth(1,R,First_Player),First_Player=[_|RFirst_Player],
	ordering_weeks(RFirst_Player),
%	last(Square,Last_Player),
%	NoWithFirst is N-(S-1)*W-1,
%	length(LastLast,NoWithFirst),
%	append(_,LastLast,Last_Player),
%	reverse(LastLast,LastLastRev),
%	ordering_weeks(LastLastRev),	
	
	Sm1 is S-1,
%	length(LAux,S),append(LAux,RR,R),
%	length(Gr1W2,Sm1),append(Gr1W2,_,RR),
	
	
	
	% SBDS Labeling
	liste_num(LIVars,2,N),
	catch(make_directory('./tmp/'),_,true),
	open('./tmp/sym_P1_P2.pl',write,SymStream),
	sym_player(LIVars,N,W,Sm1,SymStream,LSym),
	
	length(LSym,NbSym),
	write('Nb de symtrie : '),write(NbSym),nl,nl,
	close(SymStream),
	consult('./tmp/sym_P1_P2.pl'),	
	delete_file('./tmp/sym_P1_P2.pl'),
	catch(delete_directory('./tmp/'),_,true), 
%	write(LVars),nl,write(LSym),nl,
	labeling_sbds(First_Player,LSym),
%	fd_labeling(First_Player),
	
%	last_week(Gr1W2,G,S,W,LVarLastWeek),
%	labeling_sbds(LVarLastWeek,LSym,[],[val_order(max)]),!,
%	LSym2=[],
	randomize,
	labeling_sbds(LVars,LSym,[],[val_order(random),var_order(standard)]),
%	fd_labeling(LVars,[value_method(random)]),
%	convert_repr(Square,1,ListList,W,G),
%	nl,nl,nl,write_sol(ListList),nl,
%	nth(2,Square,Sec),%write(Sec),nl,
%	write_sq(Square),
	true.

golf(Square) :-
	G=5,S=3,W=7,
	% Data
	N is G*S,
	length(R,N),
	init_triangle(R,N,W),
	length(TriSInf,N),
	triangle_strict_inf(R,TriSInf,N),
	length(Square,N),
	triangle_to_square(TriSInf,R,Square),
	flatten(Square,LVars),

	% Constraint
	group_buildings(Square,R,W,S,N),
	
	% Redundant constraints
	NbGr is S*(S-1)*G // 2,
	flatten(TriSInf,TriSFlat),
	group_redund(TriSFlat,NbGr,W),
	
	% Breaking symmetries statically
	nth(1,R,First_Player),First_Player=[_|RFirst_Player],
	ordering_weeks(RFirst_Player),
	Sm1 is S-1,
	% SBDS Labeling
	liste_num(LIVars,2,N),
	catch(make_directory('./tmp/'),_,true),
	open('./tmp/sym_P1_P2.pl',write,SymStream),
	sym_player(LIVars,N,W,Sm1,SymStream,LSymPlayer),
	
	sym_comp(LSymComp,SymStream),
	append(LSymPlayer,LSymComp,LSym),
	
	length(LSym,NbSym),
	write('Nb de symtrie : '),write(NbSym),nl,nl,
	close(SymStream),
	consult('./tmp/sym_P1_P2.pl'),	
%	delete_file('./tmp/sym_P1_P2.pl'),
%	catch(delete_directory('./tmp/'),_,true), 
%	write(LVars),nl,write(LSym),nl,
	labeling_sbds(First_Player,LSym),
%	fd_labeling(First_Player),
	
%	last_week(Gr1W2,G,S,W,LVarLastWeek),
%	labeling_sbds(LVarLastWeek,LSym,[],[val_order(max)]),!,
%	LSym2=[],
	randomize,
	labeling_sbds(LVars,LSym,[],[val_order(random),var_order(standard)]),
%	fd_labeling(LVars,[value_method(random)]),
	convert_repr(Square,1,ListList,W,G),
	nl,nl,nl,write_sol(ListList),nl,
%	nth(2,Square,Sec),%write(Sec),nl,
	write_sq(Square),
	true.

init_triangle([],_,_).
init_triangle([P1|LP],N,W) :-
	length(LP,N2),
	LgP1 is N2+1,
	length(P1,LgP1),
	P1=[Id|LVar],
	fd_domain(LVar,0,W),
	Wp1 is W+1,
	fd_domain(Id,Wp1,Wp1),
	init_triangle(LP,N,W).

triangle_strict_inf(_,[],_).
triangle_strict_inf(R,[P1|TriInf],N) :-
	length(TriInf,LgRst),
	I is  N-LgRst,
	LgP1 is N-LgRst-1,
	length(P1,LgP1),
	tr_Tri(P1,R,1,I),
	triangle_strict_inf(R,TriInf,N).

tr_Tri([],_,_,_) :-!.
tr_Tri([X|LP1],R,J,I) :-
	J2 is J+1,
	I2 is I-1,
	nth(J,R,P2),
	nth(I,P2,X),
	tr_Tri(LP1,R,J2,I2).

triangle_to_square([],[],[]).
triangle_to_square([Pinf|LTriInf],[Psup|LPTriSup],[Psq|LPSq]) :-
	append(Pinf,Psup,Psq),
	triangle_to_square(LTriInf,LPTriSup,LPSq).
	
plus_diag([],[],_).	
plus_diag([P|RP],[P2|RP2],W):-
	reverse(P,P22),
	append([W],P22,P2),
	plus_diag(RP,RP2,W).

% Breaking Symmetries
ordering_weeks([]).
ordering_weeks([_]).
ordering_weeks([A|[B|R]]) :-
	A#>=B,
	ordering_weeks([B|R]).
%
last_week([],_,_,_,[]):-!.
last_week([P|LP],G,S,W,L) :-
	Sm1 is S-1,
	fix_P(P,S,Sm1,W,L1),
	last_week(LP,G,S,W,L2),
	append(L1,L2,L).

fix_P(_,_,0,_,[]):-!.
fix_P(P,S,Sm1,W,[X|R]):-
	I is S+(Sm1-1)*Sm1,
	nth(I,P,X),
%	write(I-P-X),nl,
%	X#=W,
	Sm2 is Sm1-1,
	fix_P(P,S,Sm2,W,R).

% Constraints
group_buildings([],[],_,_,_).
group_buildings([P1|LPlayer],[P11|LPlayerTri],W,S,N) :-
	Sm1 is S-1,
	NbZero is N-W*(S-1)-1,
	P11=[_|RP11],
	(NbZero=0->fd_domain(RP11,1,W);
		fd_exactly(NbZero,P1,0)),
	group_week(P1,W,Sm1),
	
	% Redundant constraints
	magicNumber(S,W,Sum1),
	compute_sum(P1,Sum2),	
	Sum2#=Sum1+W+1,

	transitivity(RP11,LPlayerTri),
	group_buildings(LPlayer,LPlayerTri,W,S,N).


group_week(_,0,_) :-!.
group_week(P1,W,S) :-
	Wm1 is W-1,	
	fd_exactly(S,P1,W),
	group_week(P1,Wm1,S).

transitivity([],_).
transitivity([_],_) :-!.
transitivity([V1|LV],[Player|LPlayer]) :-
	Player=[_|RPlayer],
	cond_const(V1,LV,RPlayer),
	transitivity(LV,LPlayer).

cond_const(_,[],_):-!.
cond_const(V1,[V2|RV],[V3|RPlayer]) :-
%	fd_cardinality([V1#>0,V2#>0,V3#>0],T1),
%	fd_domain(T2,[0,3]),
%	fd_cardinality([V1#=V2,V1#=V3,V2#=V3],T2),
%	(T1#=1)#==>T2#=0,
%	(T1#=0)#==>(T2#=0#\/T2#=3),

%	(#/\((V1#>0),(V1#=V2)))#==>(V3#=V1),
	fd_transitivity([V1,V2,V3]),

%	(V1#=V2)#==>(V3 #= V2),
%	(#/\((V1#>0),(V1#=V2)))#==>(#/\((V3 #= V2),V3#>0)),
%	(#/\((V1#>0)#/\(V2#>0),(V1#\=V2))) #==> (V3 #\= V2),
	cond_const(V1,RV,RPlayer).

% Redundant Constraints
compute_sum([], 0).
compute_sum([E|L], S):-
	compute_sum(L, S1),
	S #= S1 + E.
magicNumber(S, 1, S1):-
	!,
	S1 is S - 1.
magicNumber(S, W, MagicNumber):-
	W1 is W - 1,
	magicNumber(S, W1, MagicNumberW1),
	MagicNumber is MagicNumberW1 + W * (S - 1).
	

transitivity_redund([]).
transitivity_redund([P1|LPlayer]):-
	P1=[_|RP1],
	transitivity(RP1,LPlayer),
	transitivity_redund(LPlayer).

group_redund(_,_,0):-!.
group_redund(R,NbGr,W) :-
	fd_exactly(NbGr,R,W),
	Wm1 is W-1,
	group_redund(R,NbGr,Wm1).

% Adapted labeling
labeling_golf([_],_):-!.
labeling_golf([P|LP],K) :-
	P=[_|RP],
	randomize,
	labeling_player(RP,[],LP,1),
	Kp1 is K+1,
	labeling_golf(LP,Kp1).

labeling_first_player([],_,_,_).
labeling_first_player([V|LV],LV0,LP,J) :-
	(V>0->same_group(LV0,1,J,LP,V);true),
	Jp1 is J+1,
	append(LV0,[V],LV1),
	labeling_first_player(LV,LV1,LP,Jp1).
	
labeling_player([],_,_,_).
labeling_player([V|LV],LV0,LP,J) :-
%	write('labeling'-V),nl,
	fd_labeling(V,[value_method(random)]),
%	write(LV0-V),nl,
	(V>0->same_group(LV0,1,J,LP,V);true),
	Jp1 is J+1,
	append(LV0,[V],LV1),
	labeling_player(LV,LV1,LP,Jp1).
	
same_group([],_,_,_,_):-!.
same_group([V1|LV1],I,J,LP,V1) :-
	!,
	nth(I,LP,P2),
	JJ is J-I+1,
	nth(JJ,P2,V2),
	V2#=V1,
	Ip1 is I+1,
	same_group(LV1,Ip1,J,LP,V1).
same_group([_|LV1],I,J,LP,V2) :-
	nth(I,LP,P2),
	JJ is J-I+1,
	nth(JJ,P2,V3),
	V3#\=V2,
	Ip1 is I+1,
	same_group(LV1,Ip1,J,LP,V2).

% Symmetry constraint

sym_player([],_,_,_,_,[]):-!.
sym_player(LInd,N,0,_,SymStream,LSym):-
	!,
	sym_player_G(LInd,LInd,N,SymStream,LSym).
sym_player(LInd,N,W,S,SymStream,LSym):-
	length(LInd1,S),
	append(LInd1,LInd2,LInd),
	sym_player_G(LInd1,LInd1,N,SymStream,LSym1),

	W2 is W-1,
	sym_player(LInd2,N,W2,S,SymStream,LSym2),
	append(LSym1,LSym2,LSym).

sym_player_G([_],_,_,_,[]):-!.
sym_player_G([P1|RLInd],LInd,N,SymStream,LSym):-
	sym_player_P1(P1,RLInd,N,SymStream,LSym2,LInd),
	sym_player_G(RLInd,LInd,N,SymStream,LSym1),
	append(LSym1,LSym2,LSym).

sym_player_P1(_,[],_,_,[],_).
sym_player_P1(P1,[P2|RLInd],N,SymStream,[Sym|LSym],LInd):-
	sym_player_P1_P2(P1,P2,N,SymStream,Sym,LInd),
	sym_player_P1(P1,RLInd,N,SymStream,LSym,LInd).
	
sym_player_P1_P2(P1,P2,N,SymStream,Sym,LInd):-
	number_atom(P1,SuffixeP1),
	number_atom(P2,SuffixeP2),
	atom_concat('sym_var_',SuffixeP1,Prefixe1),
	atom_concat(Prefixe1,'_',Prefixe2),
	atom_concat(Prefixe2,SuffixeP2,Sym),
	format(SymStream,
		'~a(_,_,I1,V,I2,V):-\n\t~d is I1 mod ~d,\n\tP1y is ((I1-1)// ~d)+1,\n\t\\+member(P1y,~q),!,\n\tI2 is I1+~d-~d,!.\n',[Sym,P1,N,N,LInd,P2,P1]),
	format(SymStream,
		'~a(_,_,I1,V,I2,V):-\n\t~d is I1 mod ~d,\n\tP1y is ((I1-1)// ~d)+1,\n\t\\+member(P1y,~q),!,\n\tI2 is I1+~d-~d.\n',[Sym,P2,N,N,LInd,P1,P2]),
	format(SymStream,
		'~a(_,_,I1,V,I2,V):-\n\t~d is (I1-1) // ~d + 1,\n\tP1y is I1 mod ~d,\n\t\\+member(P1y,~q),!,\n\tI2 is I1+(~d-~d)*~d.\n',[Sym,P2,N,N,LInd,P1,P2,N]),
	format(SymStream,
		'~a(_,_,I1,V,I2,V):-\n\t~d is (I1-1) // ~d + 1,\n\tP1y is I1 mod ~d,\n\t\\+member(P1y,~q),!,\n\tI2 is I1+(~d-~d)*~d.\n',[Sym,P1,N,N,LInd,P2,P1,N]),
	
	N2 is N*N,
	liste_num(LI,1,N2),	
	findall(I1,(member(I1,LI),(P1 is I1 mod N,P1y is (I1-1)//N + 1,\+member(P1y,LInd); P2 is I1 mod N,P1y is (I1-1)//N + 1,\+member(P1y,LInd); P2 is (I1-1)//N + 1,P1y is I1 mod N,\+member(P1y,LInd);P1 is (I1-1)//N + 1,P1y is I1 mod N,\+member(P1y,LInd))),LOrb2),
	no_doublon(LOrb2,LOrb),
	subtract(LI,LOrb,LStab),
	format(SymStream,
		'~a(~q,~q).\n',[Sym,LStab,LOrb]) .

% Symtries semaines

sym_week(W,LSym,SymStream) :-
	sym_week_W1(1,2,W,LSym,SymStream).

sym_week_W1(W,_,W,_,_):-!.
sym_week_W1(W1,W2,W,LSym,SymStream) :-
	sym_week_W1_W2(W1,W2,W,LSym,SymStream),
	W1p1 is W1+1,
	W2p1 is W2+1,
	sym_week_W1(W1p1,W2p1,W,LSym,SymStream).

sym_week_W1_W2(_,W2,W,[],_) :- W2>W,!.
sym_week_W1_W2(W1,W2,W,[Sym|LSym],SymStream) :-
	number_atom(W1,SuffixeW1),
	number_atom(W2,SuffixeW2),
	atom_concat('sym_week_',SuffixeW1,Prefixe1),
	atom_concat(Prefixe1,'_',Prefixe2),
	atom_concat(Prefixe2,SuffixeW2,Sym),
	format(SymStream,
		'~a(_,_,I,~d,I,~d):-!.\n',[Sym,W1,W2]),
	format(SymStream,
		'~a(_,_,I,~d,I,~d):-!.\n',[Sym,W2,W1]),
	W2p1 is W2+1,
	sym_week_W1_W2(W1,W2p1,W,LSym,SymStream)	
	.

% Symtries semaines+player

sym_week(W,P1,P2,LSym,SymStream) :-
	sym_week_W1(1,2,W,LSym,SymStream).

sym_week_W1(W,_,W,_,_,_,_):-!.
sym_week_W1(W1,W2,W,P1,P2,LSym,SymStream) :-
	sym_week_W1_W2(W1,W2,W,P1,P2,LSym,SymStream),
	W1p1 is W1+1,
	W2p1 is W2+1,
	sym_week_W1(W1p1,W2p1,W,P1,P2,LSym,SymStream).

sym_week_W1_W2(_,W2,W,_,_,[],_) :- W2>W,!.
sym_week_W1_W2(W1,W2,W,P1,P2,[Sym|LSym],SymStream) :-
	number_atom(W1,SuffixeW1),
	number_atom(W2,SuffixeW2),
	number_atom(P1,SuffixeP1),
	number_atom(P2,SuffixeP2),
	atom_concat('sym_week_',SuffixeW1,Prefixe1),
	atom_concat(Prefixe1,'_',Prefixe2),
	atom_concat(Prefixe2,SuffixeW2,Prefixe3),
	atom_concat(Prefixe3,SuffixeP1,Prefixe4),
	atom_concat(Prefixe4,SuffixeP2,Sym),
	format(SymStream,
		'~a(_,_,I1,~d,I2,~d):-sym_var_~d_~d(_,_,I),!.\n',[Sym,W1,W2,P1,P2]),
	format(SymStream,
		'~a(_,_,I,~d,I,~d):-!.\n',[Sym,W2,W1]),
	W2p1 is W2+1,
	sym_week_W1_W2(W1,W2p1,W,LSym,SymStream)	
	.

% Symtries composes (pour (5,3,7) uniquement)
sym_comp(LSym,SymStream):-
	L=[7-(2,3),6-(4,5),5-(6,7),4-(8,9),3-(10,11),2-(12,13),1-(14,15)],
	write_sym_comp(L,LSym,SymStream).


write_sym_comp([_],[],_):-!.
write_sym_comp([W-(X1,X2)|Rest],LSym,SymStream):-
	write_sym_comp_suite(W,X1,X2,Rest,LSym1,SymStream),
	write_sym_comp(Rest,LSym2,SymStream),
	append(LSym1,LSym2,LSym).
	
write_sym_comp_suite(_,_,_,[],[],_):-!.
write_sym_comp_suite(WX,X1,X2,[WY-(Y1,Y2)|Rest],[Sym|LSym],SymStream) :-
	number_atom(X1,Suffixe1),
	number_atom(X2,Suffixe2),
	number_atom(Y1,Suffixe3),
	number_atom(Y2,Suffixe4),
	atom_concat('sym_comp_',Suffixe1,Prefixe1),
	atom_concat(Prefixe1,Suffixe2,Prefixe2),
	atom_concat(Prefixe2,Suffixe3,Prefixe3),
	atom_concat(Prefixe3,Suffixe4,Sym),
	Diff is Y1-X1,

	format(SymStream,
		'~a(_,_,I1,Val,I2,Val):-\n\t I1>18,\n\t ~d is I1 mod 15,\n\t I2 is I1+~d.\n', [Sym,X1,Diff]),
	format(SymStream,
		'~a(_,_,I1,Val,I2,Val):-\n\t I1>18,\n\t ~d is I1 mod 15,\n\t I2 is I1+~d.\n', [Sym,X2,Diff]),
	format(SymStream,
		'~a(_,_,I1,Val,I2,Val):-\n\t I1>18,\n\t ~d is I1 mod 15,\n\t I2 is I1-~d.\n', [Sym,Y1,Diff]),
	format(SymStream,
		'~a(_,_,I1,Val,I2,Val):-\n\t I1>18,\n\t ~d is I1 mod 15,\n\t I2 is I1-~d.\n', [Sym,Y2,Diff]),
	format(SymStream,
		'~a(_,_,I,~d,I,~d):-\n\t I>18.\n',[Sym,WX,WY]),
	format(SymStream,
		'~a(_,_,I,~d,I,~d):-\n\t I>18.\n',[Sym,WY,WX]),
%%%
	format(SymStream,
		'~a(_,_,I,Val,I,Val):-\n\t I < 16,!.\n', [Sym]),		
	format(SymStream,
		'~a(_,_,I,Val,I,Val):-\n\t 1 is I mod 15,!.\n', [Sym]),		
%	format(SymStream,
%		'~a(_,_,I1,Val1,I2,Val2):-\n\t ~d is I mod 15,\n\t, A is (I1-1)//15+1,\n\t,A\=~d, A\=~d,\n\t I2 is I1+~d,(Val1=WX->Val2=WY).\n', [Sym,X1,X1,Y1]),
	write_sym_comp_suite(WX,X1,X2,Rest,LSym,SymStream).
	
% Display
write_sol([]).
write_sol([P|LP]):-
	write_week(P),
	nl,
	write_sol(LP).

write_week([]).
write_week([Group|LG]):-
	write_group(Group),
	write(' |'),
	write_week(LG).

write_group([]).
write_group([I|R]):-
	write(I),write(' '),
	write_group(R).
	
convert_repr([],_,L,W,_):-
	length(L,W),
	init_list(L,[]),
	!.
convert_repr([P|LP],I,L2,W,G):-
	Ip1 is I+1,
	convert_repr(LP,Ip1,L,W,G),
	group_week(P,I,W,LG),
	rec_weeks(LG,L,W,L2).

group_week(_,_,0,[]):-!.
group_week(P,I,W,LG):-
	setof(IG,nth(IG,P,W),G),
	sort([I|G],Group1),
	Wm1 is W-1,
	group_week(P,I,Wm1,LG2),
	append([Group1],LG2,LG).
	
rec_weeks([],L,0,L).
rec_weeks([LGW|LG],L,W,L3):-
	Wm1 is W-1,
	rec_weeks(LG,L,Wm1,L2),
	nth(W,L,Week),
	(member(LGW,Week)->
		L3=L2;
		append(Week,[LGW],Week2),
		sort(Week2,Week3),
		replace_list(W,L2,Week3,L3)
	).
		
write_sq([]).
write_sq([Lg|R]):-
	write(Lg),nl,
	write_sq(R).
% Result:

% golf3(5,3,7,R):
% portnb(newVariable, 1940).
% portnb(newConstraint, 2618).
% nbcstr(6389).
