// SBDS en GNU Prolog
// Guillaume Arnaud
// Date : 25/04/2003
// Gestion des permutations en C pour la SBDS
//

#include "gprolog.h"
#include "stdlib.h"
#include "math.h"
#define	MAXSYM	4000

static int *perm_var[MAXSYM];
static int *perm_val[MAXSYM];
static int *perm_point[MAXSYM];
static int nbvar_c,nbval_c,nbpoint_c;
static int numsym_cour;
//
static int *perm_var_grp[MAXSYM];
static int *perm_val_grp[MAXSYM];
static int *perm_point_grp[MAXSYM];


Bool initialisation_sym_c(int nb_var, int nb_val, int nb_sym)
{
	int i;
	numsym_cour=0;
	nbval_c=nb_val;
	nbvar_c=nb_var;
	
	for(i=1;i<=MAXSYM;i++)
	{
		perm_var[i]=malloc(sizeof(int) * (nbvar_c+1));
		perm_val[i]=malloc(sizeof(int) * (nbval_c+1));
		perm_point[i]=malloc((sizeof(int) * nb_val + 1) * nb_var);
	}
	return TRUE;
}

void expand_perm_c(int nb_sym_old, int nb_sym_new, int nb_var, int nb_val)
{
	int i;
	for(i=nb_sym_old+1;i<=nb_sym_new;i++)
	{
		perm_var[i]=malloc(sizeof(int) * (nb_var+1));
		perm_val[i]=malloc(sizeof(int) * (nb_val+1));
		perm_point[i]=malloc((sizeof(int) * nb_var + 1) * nb_val);
	}
	return ;
}

Bool init_var_c(int num_sym, int ivar, int ivarsym)
{
	perm_var[num_sym][ivar]=ivarsym;
	return TRUE;
}
Bool init_val_c(int num_sym, int val, int valsym)
{
	perm_val[num_sym][val]=valsym;
	return TRUE;
}

Bool init_point_c(int num_sym, int ind, int indsym)
{
	perm_point[num_sym][ind]=indsym;
	return TRUE;
}

Bool image_sym_c_1(int num_sym, int ivar, int val, int *ivarsym, int *valsym)
{	
	int point,varpt,valpt;
	int *pointsym;

	point=(ivar-1)*nbval_c+val+1;
	
	pointsym=&perm_point[num_sym][point];
	if(pointsym==NULL)
	{ return FALSE;}
	else
	{
		if(*pointsym==point){return FALSE;}
		else
		{
		*ivarsym=(*pointsym-1)/nbval_c+1;
		*valsym=(*pointsym-1) % nbval_c ;
		return TRUE;}
	}
}


Bool image_sym_c_2(int num_sym, int ivar, int val, int *ivarsym, int *valsym)
{	
	*ivarsym=perm_var[num_sym][ivar];
	*valsym=perm_val[num_sym][val];
	if(ivarsym==NULL||valsym==NULL)
	{ return FALSE;}
	else
	{
		if(*ivarsym==ivar && *valsym==val){return FALSE;}
		else
		{ return TRUE;}
	}
}

// Gestion des groupes uniquement en C
Bool initialisation_grp_c(int nb_sym,int rep)
{
	if(rep==1)
	{	if(perm_point[nb_sym]==NULL)
		{
			perm_point[nb_sym]=malloc(sizeof(int) * (nbvar_c+1));}}
	else
	{
		if(perm_var[nb_sym]==NULL)
		{
		perm_var[nb_sym]=malloc(sizeof(int) * (nbvar_c+1));
		perm_val[nb_sym]=malloc(sizeof(int) * (nbval_c+1));
		}
	}
	return TRUE;
}


Bool set_grp_point_c(int num_sym, int ind, int indsym)
{
	perm_point[num_sym][ind]=indsym;
	return TRUE;
}
Bool set_grp_var_c(int num_sym, int ivar, int ivarsym)
{
	perm_var[num_sym][ivar]=ivarsym;
	return TRUE;
}
Bool set_grp_val_c(int num_sym, int val, int valsym)
{
	perm_val[num_sym][val]=valsym;
	return TRUE;
}

Bool get_grp_point_c(int num_sym, int ind, int *indsym)
{
	*indsym=perm_point[num_sym][ind];
	return TRUE;
}
Bool get_grp_var_c(int num_sym, int ivar, int *ivarsym)
{
	*ivarsym=perm_var[num_sym][ivar];
	return TRUE;
}
Bool get_grp_val_c(int num_sym, int val, int *valsym)
{
	*valsym=perm_val[num_sym][val];
	return TRUE;
}

void expand_perm_c2(int numsym, int newsym, int rep)
{
	int i,j;
	j=1;
	if(rep==1)
		{	for(i=numsym++;i<=numsym+newsym;i++)
			{perm_point[i]=perm_point_grp[j];
			j++;}
		}
	else{		for(i=numsym++;i<=numsym+newsym;i++)
			{perm_var[i]=perm_var_grp[j];perm_val[i]=perm_val_grp[j];}
			j++;}

	return ;
}

set_size_pb(int nb_var,int nb_val,int nb_point)
{	nbvar_c=nb_var;
	nbval_c=nb_val;
	nbpoint_c=nb_point;}
get_size_pb(int *nb_var,int *nb_val,int *nb_point)
{	*nb_var=nbvar_c;
	*nb_val=nbval_c;
	*nb_point=nbpoint_c;}
